﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	


End Sub

Sub write_log_header
	
	' // log app version
	Dim PM As PackageManager, p As Phone
	writelog($"

Application  ${TAB} ${PM.GetApplicationLabel(Application.PackageName)}
Version Code ${TAB} ${PM.GetVersionCode(Application.PackageName)}
Version Name ${TAB} ${PM.GetVersionName(Application.PackageName)}
Package Name ${TAB} ${Application.PackageName}
Manufacturer ${TAB} ${p.Manufacturer}
Model        ${TAB} ${p.Model}
Product      ${TAB} ${p.product.Replace("UNIWA","Atlas")}
API Level    ${TAB} ${p.SdkVersion}

"$)
	
End Sub

Sub writelog(m As String)
	
	Dim s As OutputStream, b() As Byte  
	Dim TimeFormat, myTimeFormat As String
	
	
	Try
		' // save existing time format
		TimeFormat = DateTime.TimeFormat 
				
		myTimeFormat = "HH:mm:ss.SSS"
		' // set date time format
		DateTime.TimeFormat = myTimeFormat
		' // debugger logging
		Log(DateTime.Date(DateTime.Now) & " " & DateTime.time(DateTime.Now) & " - " & m)
		
		' // create log data for file
		m = DateTime.Date(DateTime.Now) & " " & DateTime.time(DateTime.Now) & " - " & m & Chr(10) & Chr(13)
		' // restore date time format
		DateTime.TimeFormat = TimeFormat
		
		'b = m.GetBytes("iso-8859-1") 
		' // 2019.01.11 - CARECALL - SUPPORT DANISH CHAR SET
		b = m.GetBytes("Windows-1252")
		
		If File.Size(File.DirInternal, mod_core_consts.logFileName) >= 8388608 Then
			File.Delete(File.DirInternal, mod_core_consts.logFileName)
		End If
		s = File.OpenOutput(File.DirInternal, mod_core_consts.logFileName, True)

		s.WriteBytes(b,0,b.Length -1)
		s.Flush 
		s.close
		
			
	Catch
		ToastMessageShow("writelog, error - " & LastException.Message,True) 
	End Try
		
	
End Sub

Sub start_up(calledby As String)
	
	Try
		
		writelog("mod_functions:: start_up, called by " & calledby)
		' // initialise the main data structures
		app_init		
		
	Catch
		ToastMessageShow("mod_functions:: start_up, error - " & LastException.Message,True)
		writelog("mod_functions:: start_up, error - " & LastException.Message )
	End Try

End Sub

Sub app_init
	
	' // already Initialized so leave
	If Main.APPSET.IsInitialized Then
		Return
	End If
	
	Dim pm 	As PackageManager

	' // Main App Data Structure
	Main.APPSET.Initialize 
	' // SQL/KVS
	mod_settings.init_storage		
	' // settings
	mod_settings.read 	

	Main.APPSET.version = pm.GetVersionName(Application.PackageName)
	
	
End Sub
